Package org.jboss.resteasy.spi

## Interface HttpResponse

- All Superinterfaces:
    `AutoCloseable`, `Closeable`
  All Known Implementing Classes:
    `HttpServerResponse`, `HttpServletResponseWrapper`, `MockHttpResponse`, `NettyHttpResponse`, `ReactorNettyHttpResponse`, `VertxHttpResponse`

      public interface HttpResponse
      extends Closeable

  Bridge interface between the base Resteasy JAX-RS implementation and the actual HTTP transport (i.e. a servlet container)
  Version:
    $Revision: 1 $
  Author:
    Bill Burke

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addNewCookie​(javax.ws.rs.core.NewCookie cookie)` |
    `default void` | `close()` |
    `void` | `flushBuffer()` |
    `default AsyncOutputStream` | `getAsyncOutputStream()` |
    `javax.ws.rs.core.MultivaluedMap<String,​Object>` | `getOutputHeaders()` |
    `OutputStream` | `getOutputStream()` |
    `int` | `getStatus()` |
    `boolean` | `isCommitted()` |
    `void` | `reset()` | reset status and headers.
    `void` | `sendError​(int status)` |
    `void` | `sendError​(int status, String message)` |
    `void` | `setOutputStream​(OutputStream os)` |
    `void` | `setStatus​(int status)` |
    `default void` | `setSuppressExceptionDuringChunkedTransfer​(boolean suppressExceptionDuringChunkedTransfer)` |
    `default boolean` | `suppressExceptionDuringChunkedTransfer()` |

- - ### Method Detail

    - #### getStatus

          int getStatus()

    - #### setStatus

          void setStatus​(int status)

    - #### getOutputHeaders

          javax.ws.rs.core.MultivaluedMap<String,​Object> getOutputHeaders()

    - #### getOutputStream

          OutputStream getOutputStream()
                                throws IOException

      Throws:
        `IOException`

    - #### setOutputStream

          void setOutputStream​(OutputStream os)

    - #### getAsyncOutputStream

          default AsyncOutputStream getAsyncOutputStream()
                                                  throws IOException

      Throws:
        `IOException`

    - #### addNewCookie

          void addNewCookie​(javax.ws.rs.core.NewCookie cookie)

    - #### sendError

          void sendError​(int status)
                  throws IOException

      Throws:
        `IOException`

    - #### sendError

          void sendError​(int status,
                         String message)
                  throws IOException

      Throws:
        `IOException`

    - #### isCommitted

          boolean isCommitted()

    - #### reset

          void reset()

      reset status and headers. Will fail if response is committed

    - #### close

          default void close()
                      throws IOException

      Specified by:
        `close` in interface `AutoCloseable`
      Specified by:
        `close` in interface `Closeable`
      Throws:
        `IOException`

    - #### flushBuffer

          void flushBuffer()
                    throws IOException

      Throws:
        `IOException`

    - #### setSuppressExceptionDuringChunkedTransfer

          default void setSuppressExceptionDuringChunkedTransfer​(boolean suppressExceptionDuringChunkedTransfer)

    - #### suppressExceptionDuringChunkedTransfer

          default boolean suppressExceptionDuringChunkedTransfer()